echo off
REM Batch file to install and test memory library for TC or BC
REM     1996/09     kmatsui
REM     2001/12     kmatsui
REM
REM To use tcc, add an option as
REM     bc_inst tcc
REM Path to DJGPP/BIN should be set on higher precedence than DOS/BIN
REM     to use DJGPP/BIN/patch command (rather than the command of same name
REM     of MS-DOS).
REM Adjust 'CC' in builtins.mak and 'LIBDIR' in borlandc.mak according to your
REM     system beforehand.

echo on

REM for small data memory models
patch -c -B_ < bc_small.dif
if errorlevel 1 goto err

REM for small model
make -DKMMALLOC -DLIST=
make -DKMMALLOC -D_MEM_DEBUG
REM for medium model
make -DKMMALLOC -DMM=m -DLIST=
make -DKMMALLOC -D_MEM_DEBUG -DMM=m

REM for large data memory models
del yalloc.h
ren _yalloc.h yalloc.h
if "%1" == "tcc" patch -c -B_ < tc_large.dif
if "%1" == ""    patch -c -B_ < bc_large.dif

REM for compact model
make -DKMMALLOC -DLARGE -DMM=c -DLIST=
make -DKMMALLOC -D_MEM_DEBUG -DLARGE -DMM=c
REM for large model
make -DKMMALLOC -DLARGE -DMM=l -DLIST=
make -DKMMALLOC -D_MEM_DEBUG -DLARGE -DMM=l
REM for huge model
make -DKMMALLOC -DLARGE -DMM=h -DLIST=
make -DKMMALLOC -D_MEM_DEBUG -DLARGE -DMM=h

REM restore to the initial state
make clean
del yalloc.h
ren _yalloc.h yalloc.h

goto exit

:err
echo off
echo Use 'patch' of DJGPP

:exit
