# makefile for kmmalloc V.2.5 on LCC-Win32 and LCC make
#	2003/06 kmatsui,	2003/09 kmatsui
#
# To install and test kmmalloc, invoke the following make.
#	make
# Then, edit this makefile and do the make once more.
#
# This makefile always re-compiles the source files not to mangle different
#	packages.

CC = lcc
CFLAGS = -O -DPROTO
SRCS = memory.c get_env.c listheap.c
OBJS = memory.obj get_env.obj listheap.obj

# Adjust to your system.
LIBDIR = \LCC\lib

# Set your favorite pager
PAGER = notepad

# for kmatsui's malloc()
# Select one of the following 4 sets of definitions.
# CMACRO = -DKMMALLOC
# LIB = kmmalloc.lib
CMACRO = -DKMMALLOC -D_MEM_DEBUG
LIB = kmmalloc_debug.lib
# CMACRO = -DKMMALLOC -DNO_STDOUT
# LIB = kmmalloc_nostdout.lib
# CMACRO = -DKMMALLOC -D_MEM_DEBUG -DNO_STDOUT
# LIB = kmmalloc_debug_nostdout.lib

LIST = $(CMACRO)
#LIST =

all:	lib install test time

lib:
	$(CC) $(CFLAGS) $(CMACRO) memory.c
	$(CC) $(CFLAGS) $(CMACRO) get_env.c
	$(CC) $(CFLAGS) $(CMACRO) listheap.c
	-lcclib /out:$(LIB) $(OBJS)

install:
	copy /b $(LIB) $(LIBDIR)

clean:
	-del *.obj
	-del *.lib
	-del *.out
	-del *.exe
	-del *.bak
	-del memlist

test:
	$(CC) $(CFLAGS) $(LIST) test_mem.c
	lcclnk test_mem.obj $(LIB)
	-test_mem
	$(PAGER) test_mem.out
# kmmalloc and NO_STDOUT
#	$(PAGER) memlist

time:
	$(CC) $(CFLAGS) $(LIST) time_mem.c
	lcclnk time_mem.obj $(LIB)
	-time_mem > time_mem.out
	$(PAGER) time_mem.out
# kmmalloc and NO_STDOUT
#	$(PAGER) memlist
