# makefile for kmmalloc V.2.2 or later on LSI C (small model) and LSI make
#   1996/09 kmatsui,	2003/09 kmatsui
#
# To install and test kmmalloc, invoke the following two makes.
#   make CMACRO=-DKMMALLOC [LIST=] LIB=kmmalloc LIBOPT=-l all
#   make 'CMACRO=-DKMMALLOC -D_MEM_DEBUG' [LIST=] LIB=kmmall_d LIBOPT=-l all
# To test LSIC's malloc() just do
#   make
# This makefile always re-compiles the source files not to mangle different
#   packages.

CC = lcc
CFLAGS = -O -DPROTO
SRCS = memory.c get_env.c listheap.c
OBJS = memory.obj get_env.obj listheap.obj

# Adjust to your system.
LIBDIR = \LSIC86\LIB\S

CMACRO =
LIST = $(CMACRO)
LIB =
LIBOPT =

default:    test time

all:    lib install test time

lib:
	$(CC) $(CFLAGS) $(CMACRO) -c $(SRCS)
	-oar r $(LIB).lib $(OBJS)

install:
	copy /b $(LIB).lib $(LIBDIR)

clean:
	-del *.obj
	-del *.lib
	-del *.out
	-del *.exe
	-del *.bak

test:
	$(CC) $(CFLAGS) $(LIST) -otest_mem.exe test_mem.c $(LIBOPT)$(LIB)
	-test_mem
	+more < test_mem.out

time:
	$(CC) $(CFLAGS) $(LIST) -k'-s 500' -otime_mem.exe time_mem.c $(LIBOPT)$(LIB)
	-+time_mem > time_mem.out
	+more < time_mem.out
