# makefile for kmmalloc V.2.5 or later on Visual C++ and nmake
#	2003/09 kmatsui
#
# Invoke make as follows--
#	nmake [<package>=1 <opt>] [LIST=]
#		<package> should be KMMALLOC, DLMALLOC or VISUALC.
# To test and install kmmalloc, invoke the following two makes.
#	nmake KMMALLOC=1 _MEM_DEBUG=1 [LIST=]
#	nmake KMMALLOC=1 _MEM_DEBUG=1 NO_STDOUT=1 [LIST=]
# This makefile always re-compiles the source files not to mangle different
#	packages.

CFLAGS = -G7 -DPROTO
SRCS = memory.c get_env.c listheap.c
OBJS = memory.obj get_env.obj listheap.obj
CC = cl

# Adjust to your system
!if ! defined (LIBDIR)
LIBDIR = "\Program Files\Microsoft Visual Studio .net 2003\Vc7\lib"
!endif
# Set your favorite pager
PAGER = notepad

!if defined (KMMALLOC)
CMACRO = -DKMMALLOC
!if defined (_MEM_DEBUG)
CMACRO = $(CMACRO) -D_MEM_DEBUG
!if defined (NO_STDOUT)
CMACRO = $(CMACRO) -DNO_STDOUT
MLIB = kmmalloc_debug_nostdout
!else
MLIB = kmmalloc_debug
!endif
!else
!if defined (NO_STDOUT)
CMACRO = $(CMACRO) -DNO_STDOUT
MLIB = kmmalloc_nostdout
!else
MLIB = kmmalloc
!endif
!endif
!if ! defined (LIST)
LIST = $(CMACRO)
!endif

!elseif defined (DLMALLOC)
MLIB = dlmalloc
!if ! defined (LIST)
LIST = -DDLMALLOC listheap.c
!endif

!else
CMACRO =
LIST =
MLIB = libc
!endif

!if defined (KMMALLOC)

all:	lib install test time

lib:
	$(CC) $(CFLAGS) $(CMACRO) -c $(SRCS)
	-del $(MLIB).lib
	lib -out:$(MLIB).lib $(OBJS)

install:
	copy /b $(MLIB).lib $(LIBDIR)

!else

all:	test time

!endif

clean:
	-del *.obj
	-del *.exe
	-del *.lib
	-del *.out
	-del memlist

test:
	$(CC) $(CFLAGS) $(LIST) test_mem.c $(LIBDIR)\$(MLIB).lib
	-test_mem
!if defined( KMMALLOC) && defined( NO_STDOUT)
	$(PAGER) memlist
!else
	$(PAGER) test_mem.out
!endif

time:
	$(CC) $(CFLAGS) $(LIST) time_mem.c $(LIBDIR)\$(MLIB).lib
	-time_mem > time_mem.out
!if defined( KMMALLOC) && defined( NO_STDOUT)
	$(PAGER) memlist
!else
	$(PAGER) time_mem.out
!endif
